require "arsenal_console"

module ArsenalConsole

	class Colorize

		def self.successful
			return "\x1b[32mSUCCESSFUL\x1b[0m"
		end

		def self.failed
			return "\x1b[31mFAILED\x1b[0m"
		end

		def self.analytics
			return "\x1b[30;42m[ANALYTICS]\x1b[0m"
		end

		def self.cart
				return "\x1b[35;42m[CART]\x1b[0m"
		end
		
		def self.devise
			return "\x1b[37;44m[DEVISE]\x1b[0m"
		end
		
		def self.email
			return "\x1b[30;43m[EMAIL]\x1b[0m"
		end
		
		def self.sms
			return "\x1b[35;43m[SMS]\x1b[0m"
		end
		
		def self.phone
			return "\x1b[34;43m[PHONE]\x1b[0m"
		end
		
		def self.video
			return "\x1b[37;43m[VIDEO]\x1b[0m"
		end
		
		def self.fax
			return "\x1b[31;43m[FAX]\x1b[0m"
		end
		
		def self.stripe
			return "\x1b[30;46m[STRIPE]\x1b[0m"
		end
		
		def self.paypal
			return "\x1b[31;46m[PAYPAL]\x1b[0m"
		end
		
		def self.user
			return "\x1b[31;47m[USER]\x1b[0m"
		end
		
		def self.admin
			return "\x1b[37;41m[ADMIN]\x1b[0m"
		end
		
		def self.system
			return "\x1b[37;45m[SYSTEM]\x1b[0m"
		end
		
		def self.api
			return "\x1b[34;45m[API]\x1b[0m"
		end
		
		def self.webhook
			return "\x1b[36;45m[WEBHOOK]\x1b[0m"
		end
		
		def self.test
			return "\x1b[36;41m[TEST]\x1b[0m"
		end

		def self.custom(text = "CUSTOM", text_color = nil, background_color = nil)
			if text_color == nil && background_color == nil
				return "#{text}"
			else
				text_color_code = case text_color
					when "black" then "30"
					when "red" then "31"
					when "green" then "32"
					when "yellow" then "33"
					when "blue" then "34"
					when "magenta" then "35"
					when "cyan" then "36"
					when "white" then "37"
					else false
				end
				background_color_code = case background_color
					when "black" then "40"
					when "red" then "41"
					when "green" then "42"
					when "yellow" then "43"
					when "blue" then "44"
					when "magenta" then "45"
					when "cyan" then "46"
					when "white" then "47"
					else false
				end
				if text_color_code == false && background_color_code == false
					return "#{text}"
				else
					message = "\x1b["
					if text_color_code
						message << text_color_code
						if background_color_code
							message << ";#{background_color_code}"
						end
					elsif background_color_code
						message << "#{background_color_code}"
					end
					message << "m#{text}\x1b[0m"
					return message
				end
			end
		end

		def self.demo
			puts "#{self.successful}\n#{self.failed}\n#{self.analytics}\n#{self.cart}\n#{self.devise}\n#{self.email}\n#{self.sms}\n#{self.phone}\n#{self.video}\n#{self.fax}\n#{self.stripe}\n#{self.paypal}\n#{self.user}\n#{self.admin}\n#{self.system}\n#{self.api}\n#{self.webhook}\n#{self.test}\n#{self.custom} (NOTE: No Options Set)\n\n"
		end

		def self.help
			message = "\nTo see all options outputted by Colorize: ArsenalConsole::Colorize.demo\n\n"
			message << "As an example, to use the #{self.analytics} badge inside your code, you can \"puts\": ArsenalConsole::Colorize.analytics\n\n"
			message << "Make your own with ArsenalConsole::Colorize.custom by sending vars \"text\", \"text_color\", and \"background_color\"\n"
			message << "Usable colors: black, red, green, yellow, blue, magenta, cyan, white\n"
			message << "As an example: ArsenalConsole::Colorize.custom('SOMETHING', 'white', 'black') will show as #{self.custom('SOMETHING', 'white', 'black')}\n\n"
			puts message
		end
		
	end

end
